//Made by Zaltron
world
	hub="Zaltron.PetLibrary"
	name="Pet Library"
mob/Login()
	world<<"<small><b><font color = blue>[src] logs in!"
	src<<"<small><b><font color = blue>Made by Zaltron."
	..()
mob/Logout()
	world<<"<small><b><font color = blue>[src] logs out!"
	del(src)

mob/pet
	icon='Animals.dmi'
	Rat
		icon_state="Rat"
	Snake
		icon_state="Snake"
	New()
		src.Wander()
		src.Animal=src.name
turf
	icon='Turf.dmi'
	icon_state="Grass"
	name=""
mob
	icon='Animals.dmi'
	icon_state="blob"

mob/var
	list/petlist=list()
	owner=null
	wandering=1
	Animal
	standing=0
	following=0
	attacking=0
	hp=10
	opponent=null

mob/verb/Claim_Pet()
	set category = "Pet"
	for(var/mob/pet/pet in get_step(src,src.dir))
		if(pet.owner==src.name)
			src<<"<small><b><font color = blue>You already own this animal."
			return
		if(pet.owner!=null)
			src<<"<small><b><font color = blue>Someone already owns this animal."
			return
		if(src.petlist.len>=1)
			src<<"<small><b><font color = blue>You already have a animal."
			return
		src<<"<small><b><font color = blue>You get a new animal named \icon[pet][pet]!"
		pet.owner=src.name
		pet.wandering=0
		pet.icon_state="[pet.Animal]Collar"//This is for if you want a collar if not delete it
		src.petlist+=pet
		verbs+=/mob/proc/Name_Pet
		verbs+=/mob/proc/Pet_Wander
		verbs+=/mob/proc/Pet_Stay
		verbs+=/mob/proc/Pet_Follow
		verbs+=/mob/proc/Release_Pet
		verbs+=/mob/proc/Watch_Pet
		verbs+=/mob/proc/Pets
		verbs+=/mob/proc/Pet_Follow_Someone
		verbs+=/mob/proc/Pet_Attack_Someone
		src.PetMove()
		return

mob/proc/Release_Pet()
	set category = "Pet"
	var/list/pets=list()
	for(var/mob/pet in src.petlist)pets+=pet
	pets+="Cancel"
	var/mob/pet=input("Select a animal to Remove","Select") in pets
	if(pet=="Cancel")return
	pet.icon_state="[pet.Animal]"
	src.petlist-=pet
	pet.owner=null
	pet.wandering=0
	pet.following=0
	pet.standing=0
	pet.attacking=0
	spawn(18)
		pet.wandering=1
		pet.Wander()
	src<<"<small><b><font color = blue>You say farewell to \icon[pet][pet]."
	src.client.eye=src
	if(src.petlist.len<=0)
		verbs-=/mob/proc/Name_Pet
		verbs-=/mob/proc/Pet_Wander
		verbs-=/mob/proc/Pet_Stay
		verbs-=/mob/proc/Pet_Follow
		verbs-=/mob/proc/Release_Pet
		verbs-=/mob/proc/Watch_Pet
		verbs-=/mob/proc/Pets
		verbs-=/mob/proc/Pet_Follow_Someone
		verbs-=/mob/proc/Pet_Attack_Someone
	src.client.perspective = MOB_PERSPECTIVE

mob/proc/Name_Pet()
	set category = "Pet"
	var/list/pets=list()
	for(var/mob/pet in src.petlist)pets+=pet
	pets+="Cancel"
	var/mob/pet=input("Select a animal to name","Select") in pets
	if(pet=="Cancel")return
	pet.name=input("Select a name for your pet","Namimg")

mob/proc/Pet_Wander()
	set category = "Pet"
	var/list/pets=list()
	for(var/mob/pet in src.petlist)if(pet.wandering==0||pet.standing==0||pet.following==1||pet.attacking==1)pets+=pet
	pets+="Cancel"
	var/mob/pet=input("Select a animal to let wander","Select") in pets
	if(pet=="Cancel")return
	pet.following=0
	pet.standing=0
	pet.wandering=1
	pet.attacking=0
	pet.Wander()

mob/proc/Pet_Stay()
	set category = "Pet"
	var/list/pets=list()
	for(var/mob/pet in src.petlist)if(pet.wandering==0||pet.standing==0||pet.following==1||pet.attacking==1)pets+=pet
	pets+="Cancel"
	var/mob/pet=input("Select a animal to let wander","Select") in pets
	if(pet=="Cancel")return
	pet.following=0
	pet.standing=1
	pet.wandering=0
	pet.attacking=0

mob/proc/Pet_Follow()
	set category = "Pet"
	var/list/pets=list()
	for(var/mob/pet in src.petlist)if(pet.wandering==1||pet.standing==1||pet.following==1||pet.attacking==1)pets+=pet
	pets+="Cancel"
	var/mob/pet=input("Select a animal to follow you.","Select") in pets
	if(pet=="Cancel")return
	pet.following=0
	pet.standing=0
	pet.wandering=0
	pet.attacking=0
	src.PetMove()
mob/var/petfolowsomeone=0
mob/proc/Pet_Follow_Someone()
	set category = "Pet"
	if(src.petfolowsomeone==1)return
	src.petfolowsomeone=1
	var/list/pets=list()
	var/list/mobs=list()
	for(var/mob/pet in src.petlist)pets+=pet
	pets+="Cancel"
	var/mob/pet=input("Select a pet to follow someone.","Select") in pets
	if(pet=="Cancel")
		src.petfolowsomeone=0
		return
	for(var/mob/m in world)if(m.key!=null)mobs+=m
	mobs+="Cancel"
	var/mob/m=input("Select a person for you pet to have your pet follow.","Select") in mobs
	if(m=="Cancel")
		src.petfolowsomeone=0
		return
	pet.standing=0
	pet.wandering=0
	pet.following=1
	pet.attacking=0
	src.petfolowsomeone=0
	pet.Pet_Follow_Mob(m)

mob/var/petattacksomeone=0
mob/proc/Pet_Attack_Someone()
	set category = "Pet"
	if(src.petattacksomeone==1)return
	src.petattacksomeone=1
	var/list/pets=list()
	var/list/mobs=list()
	for(var/mob/pet in src.petlist)pets+=pet
	pets+="Cancel"
	var/mob/pet=input("Select a animal to Attack with.","Select") in pets
	if(pet=="Cancel")
		src.petattacksomeone=0
		return
	for(var/mob/m in view(pet))if(m.key!=null||istype(m,/mob/pet))
		if(m.owner!=src.name&&m!=src)mobs+=m
	mobs+="Cancel"
	var/mob/m=input("Select a person/or animal to Attack.","Select") in mobs
	if(m.hp<1)
		src<<"There too weak at the moment!"
		src.petattacksomeone=0
		return
	if(m=="Cancel")
		src.petattacksomeone=0
		return
	pet.standing=0
	pet.wandering=0
	pet.following=0
	pet.attacking=1
	pet.opponent=m.name
	src.petattacksomeone=0
	pet.Pet_Attack_Mob(m)

mob/proc/Watch_Pet()
	set category = "Pet"
	var/list/pets=list()
	for(var/mob/pet in src.petlist)pets+=pet
	pets+="Cancel"
	var/mob/pet=input("Select a animal to watch.","Select") in pets
	if(pet=="Cancel")return
	verbs-=/mob/proc/Watch_Pet
	verbs+=/mob/proc/Stop_Watching
	src.client.eye=pet
	src.client.perspective = EYE_PERSPECTIVE

mob/proc/Stop_Watching()
	set category = "Pet"
	verbs+=/mob/proc/Watch_Pet
	verbs-=/mob/proc/Stop_Watching
	src.client.eye=src
	src.client.perspective = MOB_PERSPECTIVE

mob/proc/Pets()
	set category = "Pet"
	src<<"<small><b><font color = blue><u>Animal you own."
	for(var/mob/pet in src.petlist)src<<"<small><b><font color = blue>\icon[pet][pet]"

mob/proc/Pet_Attack(mob/m)
	for(var/mob/p in get_step(src,src.dir))if(p.name==m.name&&p.name==src.opponent&&p.hp>0)
		p.hp-=1
		view(src)<<"\icon[p]<small><b><font color = red>[p] loses 1 hp, [p]'s hp: [p.hp]"
		if(p.hp<=0)
			src.attacking=0
			src.wandering=1
			spawn(10)src.Wander()
			if(istype(p,/mob/pet))
				p.attacking=0
				spawn(20)p.hp=10
				if(src.owner!=null)
					view(src)<<"<small><b><font color = red>[p] is killed by [src.owner]'s pet: \icon[src][src]."
				if(src.owner==null)
					view(src)<<"<small><b><font color = red>[p] is killed by a wild [src.Animal] named: \icon[src][src]."
				if(p.owner!=null)
					for(var/mob/c in world)if(c.name==m.owner)
						p.loc=locate(10,10,1)
						c.Pet_Dead(m,src)
						return
				if(p.owner==null)
					p.loc=locate(10,10,1)
					m.Pet_Dead(m,m)
					return
			else
				if(src.owner!=null)view()<<"<small><b><font color = red>[p] is killed by [src.owner]'s pet: \icon[src][src]."
				if(src.owner==null)view()<<"<small><b><font color = red>[p] is killed by a wild [src.Animal] named: \icon[src][src]."
				p.hp=10
				p.loc=locate(1,1,1)
		return

mob/proc/Pet_Attack_Mob(mob/m)
	if(src.attacking!=1)return
	if(src.attacking==1&&m.hp>0)
		for(var/mob/p in get_step(src,NORTH))if(p==m)src.dir=NORTH
		for(var/mob/p in get_step(src,EAST))if(p==m)src.dir=EAST
		for(var/mob/p in get_step(src,SOUTH))if(p==m)src.dir=SOUTH
		for(var/mob/p in get_step(src,WEST))if(p==m)src.dir=WEST
		for(var/mob/p in get_step(src,NORTHEAST))if(p==m)src.dir=NORTHEAST
		for(var/mob/p in get_step(src,NORTHWEST))if(p==m)src.dir=NORTHWEST
		for(var/mob/p in get_step(src,SOUTHEAST))if(p==m)src.dir=SOUTHEAST
		for(var/mob/p in get_step(src,SOUTHWEST))if(p==m)src.dir=SOUTHWEST
		spawn(2)src.Pet_Attack(m)
		spawn(4)if(src.attacking==1)src.Pet_Attack_Mob(m)
		if(istype(m,/mob/pet)&&m.attacking==0)
			m.attacking=1
			m.opponent=src.name
			spawn(15)m.Pet_Attack_Mob(src)
			m.wandering=0
			m.following=0
			m.standing=0
		step_to(src,m,1)
mob/proc/Wander()
	if(src.wandering==1)
		var/w=rand(1,4)
		if(w==1)step(src,NORTH)
		if(w==2)step(src,SOUTH)
		if(w==3)step(src,EAST)
		if(w==4)step(src,WEST)
		spawn(15)src.Wander()

mob/proc/Pet_Follow_Mob(mob/m)
	if(src.following==1)
		step_to(src,m,1)
		src.Pet_Attack(m)
		spawn(1)src.Pet_Follow_Mob(m)


mob/proc/Pet_Dead(mob/pet,mob/attacker)
	set category = "Pet"
	pet.icon_state="[pet.Animal]"
	src.petlist-=pet
	pet.wandering=1
	pet.following=0
	pet.standing=0
	pet.attacking=0
	spawn(18)
		pet.wandering=1
		pet.Wander()
	if(pet.owner!=null)src<<"<small><b><font color = red>Your pet \icon[pet][pet] has been killed by [attacker.owner]'s [attacker]!"
	if(pet.owner==null)src<<"<small><b><font color = red>Your pet \icon[pet][pet] has been killed by a wild [pet.Animal] named: \icon[src][src]."
	pet.owner=null
	if(src.key!=null)src.client.eye=src
	if(src.petlist.len<=0&&src.key!=null)
		verbs-=/mob/proc/Name_Pet
		verbs-=/mob/proc/Pet_Wander
		verbs-=/mob/proc/Pet_Stay
		verbs-=/mob/proc/Pet_Follow
		verbs-=/mob/proc/Release_Pet
		verbs-=/mob/proc/Watch_Pet
		verbs-=/mob/proc/Pets
		verbs-=/mob/proc/Pet_Follow_Someone
		verbs-=/mob/proc/Pet_Attack_Someone
	if(src.key!=null)spawn(2)src.client.perspective = MOB_PERSPECTIVE

mob/proc/PetMove()
	if(src.petlist.len>=1)
		for(var/mob/pet/pet in world)if(pet.owner==src.name&&pet.wandering==0&&pet.standing==0&&pet.following==0&&pet.attacking==0)
			pet.loc=locate(src.x,src.y,src.z)
			pet.dir=src.dir

mob/Move()
	usr.PetMove()
	..()


mob/var/talking=0
mob/verb/Say(msg as text)
	if(talking==1)return
	if(!msg)return
	talking=1
	msg=copytext(msg,1,501)
	world<<"<b>[src]</b>: [html_encode(msg)]"
	spawn(8)talking=0
mob/verb/Who()
	var/i=0
	for(var/mob/M in world)if(M.key!=null)i++
	usr<<"<b><small><u>Players in World: [i]"
	for(var/mob/M in world)if(M.key!=null)usr<<"\icon[M][M.name]([M.key])"